<?php
// Internetový obchod pomocí PHP & MySQL (3. vydání) verze skriptu 6.02.01
// stránky projektu www.iPraxe.com
// (c) 2001,2002,2003,2004,2005,2006 
// Autor: Tomáš Mihule e-mail: mihule@ipraxe.com

/********** převádí datum na český tvar **********/
function czechdate($sqldatum) {
   if($sqldatum <> "0000-00-00"):
      return ereg_replace("([0-9]{4})-([0-9]{2})-([0-9]{2})","\\3.\\2.\\1",$sqldatum);
   else:
      return "";
   endif;
}

/********** formát měny **********/
function cena($castka, $mena = '') {
$castka = intval($castka);
if($castka == 0):
   return '';
else:
   return number_format($castka, 2, '.', '').$mena;
endif;
}

/********** formátování výstupu pro html **********/
function CSS_FORMAT($vystup, $nazev, $nadpis, $verze, $typ) {
$css_nazev = strtolower(bez_diakritiky($nazev));
if($typ == 'blok'):
   if($_SESSION['prihlaseny'] == 'admin') $nadpis .= ' <span class="admin">['.$css_nazev.']</span>';
   $nadpis = $nadpis ? "\n".'<h3>'.$nadpis.'<span></span></h3>' : '';
   return '
      <!-- blok.'.$css_nazev.' (verze '.$verze.') -->  
      <div id="blok_'.$css_nazev.'_obal" class="blok_obal">
         <div id="blok_'.$css_nazev.'" class="blok">'.$nadpis.'
         '.$vystup.'
         </div>
      </div>
      <!-- blok.'.$css_nazev.'.konec -->
';
endif;
if($typ == 'telo'):
   $nadpis = $nadpis ? "\n".'<h2 class="h2_'.$css_nazev.'">'.$nadpis.'<span></span></h2>' : '';
   return '
      <!-- telo.'.$css_nazev.' (verze '.$verze.') -->  
      <div id="telo_'.$css_nazev.'_obal" class="telo_obal">
         <div id="telo_'.$css_nazev.'" class="telo">'.$nadpis.'
         '.$vystup.'
         </div>
      </div>
      <!-- telo.'.$css_nazev.'.konec -->
';
endif;
if($typ == 'text'):
   $nadpis = $nadpis ? '<span class="popisek_'.$css_nazev.'">'.$nadpis.'</span> ' : '';
   return '<!-- text.'.$css_nazev.'.verze_'.$verze.' -->'.$nadpis.'<span class="text_'.$css_nazev.'">'.$vystup.'</span><!-- text.'.$css_nazev.'.konec -->';
endif;
}

/********** kontrola e-mailové adresy **********/
function je_mail($mail) {
if(!ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.'@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $mail)):
   return TRUE;
else:
   return FALSE;
endif;
}

/********** zápis do logu **********/
function do_logu($hlaseni) {
if(LOGBD == 'ano'):
   ipraxe_mysql_query('insert into ".DBPREFIX."log 
                       values("", "'.date('Y-m-d H:i:s').'", "'.$hlaseni.'", "'.@$_REQUEST['PHPSESSID'].'", "'.@$_SESSION['prihlaseny'].'", "'.$_SERVER["REMOTE_ADDR"].'") ');    
endif;
}

/********** log **********/
function ipraxe_mysql_query($dotaz){
   // zde můžete logovat všechny dotazy do databáze
   return mysql_query($dotaz);
}

/********** kešování **********/
function kesovani_generovani($pozadovana_stranka, $sablona){
if(is_file('./cache/'.@$pozadovana_stranka) and KESOVANI == 'ano'):
   // vezmeme stránku z cache
   require('./cache/'.$pozadovana_stranka);
   $_SESSION['cache'] = 'ano';
else:
   // generujeme stránku dynamicky - připojení stránky dle akce 
   $pripojeni = @include('./sablony/'.SABLONA.'/akce_'.$_SESSION['a'].'.php'); 
   if($pripojeni == FALSE):
      $pripojeni = @include('./ipraxe3/akce_'.$_SESSION['a'].'.php'); 
   endif;
   if($pripojeni == FALSE) echo 'Neni mozne nacist sablonu.';
   ob_start();
   // $vystupni_stranka = file($sablona);
   // natáhneme šablonu
   require($sablona);
   // provedeme záměny do šablony
   $zameny = array("\t" => "", "\n" => "", "\r" => "", "     " => " ", "    " => " ", "   " => " ", "  " => " ", "  " => " ", "  " => " ");
   $vystup_html = strtr(ob_get_contents(), $zameny);
   if(ob_end_clean());
   // vypíšeme výstup
   if(KESOVANI == 'ano'):
      $fp = fopen('./cache/'.$pozadovana_stranka, 'w');
      fputs($fp, $vystup_html);
   endif;
   $_SESSION['cache'] = 'ne';
   print($vystup_html);   
endif;
}

/********** přepočet cen **********/
function cenavypocet($cena, $dph, $skutsdph, $skutbez) {
if($cena == $skutsdph or $cena == '' or intval($cena) == 0):
   $vystup = '';
else:
   $kc_usetrite = $cena - $skutsdph;
   $procent_usetrite = intval($kc_usetrite/($cena/100)*10)/10;
   $vystup = '
   <p class="beznacena">Běžná cena: <span class="cena">'.cena($cena, ' Kč').'</span></p>
   <p class="usetrite">Ušetříte: <span class="cena">'.cena($kc_usetrite, ' Kč').'</cena> (<span class="procenta">'.$procent_usetrite.'</span> %)</p>
   ';
endif;
$vystup = '                 
<p class="nasecena">Naše cena: <span class="cena"> '.cena($skutsdph, ' Kč').'</span></p>
<p class="bezdph">bez DPH: <span class="cena"> '.cena($skutbez, ' Kč').'</span></p>'.$vystup;
return $vystup;
}

/********** zaokrouhlování **********/
function na50nik($cislo) {
$halere = $cislo - intval($cislo);
$halere = 1 * $halere;
if($halere > 0.7501)  return intval($cislo) + 1;
if($halere > 0.2501 and $halere <= 0.7501)  return intval($cislo) + 0.50;
if($halere == 0) return $cislo;
if($halere <= 0.2501)  return intval($cislo);
}

/********** mazání starých kešovaných souborů **********/
function uklid_cache() {
$adresar_cache = opendir('./cache');
while($soubor_cache = readdir($adresar_cache) ):
   if(filemtime('./cache/'.$soubor_cache) + 7200 < Date("U")):
      @unlink('./cache/'.$soubor_cache);
   endif;
endwhile;
}

/********** odkaz v obchodě na administrátorské stránky **********/
function edit_admin($edit, $x) {
   $vystup = '';
   if($_SESSION['prihlaseny'] == 'admin'):
      $vystup = '<p class="admin_edit"><a href="./admin/index.php?aa=vyredit&amp;d='.$x.'" target="edit">EDIT</a></p>';
   endif;
return $vystup ? $vystup : '';
}

/********** odkaz v obchodě na administrátorské stránky **********/
function text_admin($edit) {
   $vystup = '';
   if($_SESSION['prihlaseny'] == 'admin'):
      $vystup = '<p class="admin_edit"><a href="./admin/index.php?aa=texty&amp;i='.$edit.'" target="edit">EDIT</a></p>';
   endif;
return $vystup ? $vystup : '';
}

/********** možnost rozšíření o texy (www.texy.info) **********/
function texy($text) {
// vložíme texy, nebo podobný formátovací systém
if(@include('../../texy/texy.php')):
   // vytvoříme objekt
   $texy = &new Texy();
   // můžeme jej nakonfigurovat
   $texy->utf = true;
   $texy->imageModule->root  = 'galerie/';
   $texy->modules->TexyLongWordsModule->shy = '&shy;<wbr />';
   // a zpracujeme vstupní text $s
   $html = $texy->process($text);
   // vracíme z funkce konvertovaný text
   return $html;
else:
   return $text;
endif;
}

/********** možné stavy objednávek **********/
function stav_obj($n) {
$stavy_obj[0] = 'nová';
$stavy_obj[1] = 'objednávka se řeší';
$stavy_obj[2] = 'zásilka odeslána';
$stavy_obj[3] = 'vyřízeno';
$stavy_obj[4] = 'storno';
return @$stavy_obj[$n];     
}

/********** vrací rozbalovací seznam nebo název **********/
function platba($zvolena = 'dobirka', $jen_nazev = 'ne') {
$platby = array ('dobirka' => 'dobírkou', 'predem' => 'předem', 'faktura' => 'faktura' );
if($jen_nazev == 'ano') return @$platby[$zvolena];  
$vystup = '<select name="n_obvplatba" id="n_obvplatba">';
reset($platby);
for($i = 0; $i < count($platby); $i++):
   if($zvolena == key($platby)):
      $oznac = 'selected = "selected"';
   else:
      $oznac = '';
   endif;
   $vystup .= '<option '.$oznac.' value="'.key($platby).'">'.current($platby).'</option>';
   next($platby);
endfor;
$vystup .= '</select>';
return $vystup;
}

/********** překontroluje přihlášeného uživatele **********/
function admin() {
$_SESSION['prihlaseny'] = '';
$dotaz = ipraxe_mysql_query('select * from '.DBPREFIX.'zakaznici where zak_prihlaseny = "'.@$_REQUEST['PHPSESSID'].'" and zak_prihlaseny <> ""');
$stav = FALSE;
while($radek = mysql_fetch_array($dotaz)):
   $stav = TRUE;
   $_SESSION['prihlaseny'] = $radek['zak_user'];
endwhile;
}

/********** načte obsah košíku (stručný přehled) **********/
function v_kosiku() {
// provedeme součet v košíku a uložíme pro potřeby stránky 
$dotaz = ipraxe_mysql_query('select count('.DBPREFIX.'kosik.kos_vyr_id) as "polozek", sum('.DBPREFIX.'kosik.kos_mnozstvi) as "kusu", 
                            sum(('.DBPREFIX.'vyrobky.vyr_nase_sdph+vyr_recyklace)*'.DBPREFIX.'kosik.kos_mnozstvi) as "celcena"
                            from '.DBPREFIX.'kosik, '.DBPREFIX.'vyrobky
                            where '.DBPREFIX.'vyrobky.vyr_id = '.DBPREFIX.'kosik.kos_vyr_id 
                            and '.DBPREFIX.'kosik.kos_session = "'.@$_REQUEST['PHPSESSID'].'" and kos_session <> ""
                            ');                            
$row  =  mysql_fetch_array($dotaz);
$vKPol = ' žádné zboží není v košíku ';
if($row['polozek']=='1') $vKPol = ' položka | ';
if($row['polozek']>'1') $vKPol = ' položky | ';
if($row['polozek']>'4') $vKPol = ' položek | ';
if($row['kusu']==''){ $vKKus = ''; $vKKc='';}
if($row['kusu']=='1') { $vKKus = ' kus | cena: '; $vKKc=' Kč';}
if($row['kusu']>'1') { $vKKus = ' kusy | cena: '; $vKKc=' Kč';}
if($row['kusu']>'4') { $vKKus = ' kusů | cena: '; $vKKc=' Kč';}
$vystup = $row['polozek'].$vKPol.$row['kusu'].$vKKus."<strong>".$row['celcena']."</strong>".$vKKc;
if($row['celcena'] == 0) $vystup = ' žádné zboží není v košíku ';
return $vystup;
}

/********** rozbalovací nabídka hlavních oddělení **********/
function hlavni_oddeleni($aktual = -1) {
$vystup = "<select name='hled_kategorie'>
<option value=''>- nerozhoduje -</option>\n";
$dotaz = MySQL_Query('SELECT * FROM '.DBPREFIX.'kategorie
                      WHERE kat_rodic = 0
                      ORDER BY kat_razeni DESC');
while ($radek = MySQL_Fetch_array($dotaz)):
   $vystup .= "<option value='".$radek["kat_id"]."'>".$radek["kat_nazev"]."</option>\n";
endwhile;
  $vystup .= "</select>"; 
  return $vystup;
}

/********** seznam výrobců **********/
function vyrobci($aktual = -1) {
$vystup = "<select name='hled_vyrobce'>
<option value=''>- nerozhoduje -</option>\n";
$dotaz = MySQL_Query('select * from '.DBPREFIX.'vyrobky
                      group by vyr_vyrobce
                      order by vyr_vyrobce');
while ($radek = MySQL_Fetch_array($dotaz)):
   $vystup .= "<option value='".$radek["vyr_vyrobce"]."'>".$radek["vyr_vyrobce"]."</option>\n";
endwhile;
  $vystup .= "</select>"; 
  return $vystup;
}

/********** vypíše obsah pole (jen pro ladění programu) **********/
function vypis_pole($pole) {
reset($pole);
for($i=0;$i<30;$i++):
   if(key($pole)):
      echo key($pole);
      echo ' = '.current($pole).'<br />';
   endif;
next($pole);
endfor;
}

/********** funkce vrací text bez diakritiky **********/
function bez_diakritiky($text) {
$s = array("á","ä","č","ď","é","ě","ë","í","ň","ó","ö","ř","š","ť","ú","ů","ü","ý","ž","Á","Ä","Č","Ď","É","Ě","Ë","Í","Ň","Ó","Ö","Ř","Š","Ť","Ú","Ů","Ü","Ý","Ž");
$bez = array("a","a","c","d","e","e","e","i","n","o","o","r","s","t","u","u","u","y","z","A","A","C","D","E","E","E","I","N","O","O","R","S","T","U","U","U","Y","Z");
return str_replace($s, $bez, $text); 
}

/********** 'hezčí' odkazy s rewrite on **********/
function odkaz($text, $id, $typ = 'vyrobek') {
if(REWRITE == 'ano'):
   $s = array(" ","-","!","?","'",'"',"/",">","<",",",".","á","ä","č","ď","é","ě","ë","í","ň","ó","ö","ř","š","ť","ú","ů","ü","ý","ž","Á","Ä","Č","Ď","É","Ě","Ë","Í","Ň","Ó","Ö","Ř","Š","Ť","Ú","Ů","Ü","Ý","Ž","___","__","+",":");
   $bez = array("_","_","_","_","_","_","_","_","_","_","_","a","a","c","d","e","e","e","i","n","o","o","r","s","t","u","u","u","y","z","A","A","C","D","E","E","E","I","N","O","O","R","S","T","U","U","U","Y","Z","_","_","_","_");
   $text = strtolower(str_replace($s, $bez, $text));
   return $typ.'-'.$text.'-id-'.$id;
else:
   return 'index.php?a=detail&amp;d='.$id;
endif; 
}

/********** vrací rodiče kategorie **********/
function rodic($kategorie){
// rodičovská kategorie 
$dotaz = ipraxe_mysql_query('select * from '.DBPREFIX.'kategorie where kat_id ='.$kategorie); 
while($radek = mysql_fetch_array($dotaz)):
   return $radek['kat_rodic'];                                               
endwhile;
}

/********** čísla stránek k listování **********/
function listovani($celkem_nalezeno) {
$stranek = ceil($celkem_nalezeno/$_SESSION['lk']);
if($celkem_nalezeno == 1) $polozek = "položka";
if($celkem_nalezeno > 1) $polozek = "položky";
if($celkem_nalezeno > 1) $polozek = "položek";
//if($stranek > 0) $txt_stranek = "";   
$txt_stranek = "";    
if($stranek == 1)$txt_stranek = "$celkem_nalezeno $polozek ($stranek stránka)";
if($stranek > 1) $txt_stranek = "$celkem_nalezeno $polozek ($stranek stránky)";
if($stranek > 4) $txt_stranek = "$celkem_nalezeno $polozek ($stranek stránek)";
$vystup = '<p class="strankovani_uvod">'.$txt_stranek.'</p> '; 
$vystup .= '<p class="strankovani_stranky">';
for($i=1 ;$i<=$stranek; $i++):
   if($_SESSION['lo'] == $_SESSION['lk']*($i-1)):
      $vystup .=  $i.' ';
   else:
      $vystup .= '<a href="index.php?a='.$_SESSION['a'].'&amp;k='.$_SESSION['k'].'&amp;lo='.($_SESSION['lk']*($i-1)).'">'.$i.'</a> ';
   endif;
endfor;
$vystup .= '</p>';
return $vystup;
} 

/********** převod objednávky z xml **********/
function objednavka_xml_html($xml) {
$zameny = array(
'<?xml version="1.0" encoding="utf-8"?>' => '',
'<objednavka_ipraxe>' => '', '</objednavka_ipraxe>' => '',
'<datum>' => '<h2>Objednávka ze dne ', '</datum>' => '</h2>',
'<vs>' => '<p class="vs"><span>variabilní symbol:</span> <strong>', '</vs>' => '</strong></p>',
'<uhrada>' => '<p class="uhrada"><span>forma úhrady:</span> <strong>', '</uhrada>' => '</strong></p>',
'<id_zakaznika>' => '<!-- ', '</id_zakaznika>' => ' -->',
'<firma>' => '<div class="adresa"><p class="p_objednavatel">OBJEDNAVATEL:</p><p>', '</firma>' => '</p>',
'<jmeno>' => '<p>', '</jmeno>' => '</p>',
'<ulice>' => '<p>', '</ulice>' => '</p>',
'<mesto>' => '<p>', '</mesto>' => '</p>',
'<psc>' => '<p>', '</psc>' => '</p></div>',
'<ic>' => '<p>IČ: ', '</ic>' => '</p>',
'<dic>' => '<p>DIČ:', '</dic>' => '</p>',
'<dorucovaci>' => '<p>Doručovací adresa: <strong>', '</dorucovaci>' => '</strong></p>',
'<email>' => '<p>E-mail: ', '</email>' => '</p>',
'<poznamka>' => '<p>', '</poznamka>' => '</p>',
'<polozky>' => '<table><tr><th>ID</th><th>kód</th><th>zboží</th><th>množství</th><th>cena</th><th>DPH</th><th>recykl<sup>*)</sup></th><th>celkem</th></tr>', '</polozky>' => '</table>',
'<polozka>' => '<tr>', '</polozka>' => '</tr>',
'<vyr_id>' => '<td class="vyr_id">', '</vyr_id>' => '&nbsp;</td>',
'<vyr_cislo>' => '<td class="vyr_cislo">', '</vyr_cislo>' => '&nbsp;</td>',
'<popis>' => '<td class="popis">', '</popis>' => '&nbsp;</td>',
'<mnozstvi>' => '<td class="mnozstvi">', '</mnozstvi>' => '&nbsp;</td>',
'<cena>' => '<td class="cena">', '</cena>' => '&nbsp;</td>',
'<dph>' => '<td class="dph">', '</dph>' => '&nbsp;</td>',
'<recpoplatek>' => '<td class="recpoplatek">', '</recpoplatek>' => '&nbsp;</td>',
'<sum>' => '<td class="sum">', '</sum>' => '&nbsp;</td>',
'<celkem>' => '<p class="celkem">CELKOVÁ CENA: ', '</celkem>' => '</p>
<p>Objednávka je závazná</p>
'
);
$objednavka = strtr($xml, $zameny);
return $objednavka;
}

/********** převod objednávky z xml do mailu **********/
function objednavka_xml_mail($xml) {
$zameny = array(
'<?xml version="1.0" encoding="utf-8"?>' => '',
'<objednavka_ipraxe>' => '', '</objednavka_ipraxe>' => '',
'<datum>' => 'Objednávka ze dne ', '</datum>' => '',
'<vs>' => 'variabilní symbol: ', '</vs>' => '',
'<uhrada>' => 'forma úhrady: ', '</uhrada>' => '',
'<id_zakaznika>' => 'zakaznické číslo: ', '</id_zakaznika>' => '',
'<firma>' => "\n".'OBJEDNAVATEL:', '</firma>' => '',
'<jmeno>' => '', '</jmeno>' => '',
'<ulice>' => '', '</ulice>' => '',
'<mesto>' => '', '</mesto>' => '',
'<psc>' => '', '</psc>' => '',
'<ic>' => 'IČ: ', '</ic>' => '',
'<dic>' => 'DIČ:', '</dic>' => '',
'<dorucovaci>' => "\n\n".'Doručovací adresa: ', '</dorucovaci>' => '',
'<email>' => "\n".'E-mail: ', '</email>' => '',
'<poznamka>' => '', '</poznamka>' => '',
'<polozky>' => "\n".'Objednané položky', '</polozky>' => '',
'<polozka>' => '----------------------------------------', '</polozka>' => '',
'<vyr_id>' => 'id: ', '</vyr_id>' => ' ',
'<vyr_cislo>' => 'číslo: ', '</vyr_cislo>' => ' ',
'<popis>' => 'název:  ', '</popis>' => ' ',
'<mnozstvi>' => 'množství: ', '</mnozstvi>' => ' ks ',
'<cena>' => 'cena: ', '</cena>' => ' Kč',
'<dph>' => 'DPH: ', '</dph>' => '%',
'<recpoplatek>' => 'recykl. poplatek: ', '</recpoplatek>' => ' ',
'<sum>' => 'Celkem za položku: ', '</sum>' => ' Kč',
'<celkem>' => '========================================
CELKOVÁ CENA OBJEDNÁVKY: ', '</celkem>' => ' Kč'
);
$text = "KOPIE OBJEDNAVKY\n\nV internetovém obchodě ".NAZEV_OBCHODU." byla učiněna následující objednávka. Případné dotazy směřujte na ".EMAIL_OBCHODU.". Vaši objednávku vyřídíme v nejkratším možném termínu.";
$objednavka = bez_diakritiky($text."\n\n".strtr($xml, $zameny));
return $objednavka;
}

/********** odesílání mailů **********/
function odesli_mail($nazev, $text, $od, $komu) {
    $hlavicka = "From: $od\r\n";
    $hlavicka.= "Reply-To: $komu\r\n";
    $hlavicka.= "X-Mailer: php-mailer";
    do_logu("mail: $komu, $nazev, $hlavicka");
    if(@mail($komu, $nazev, $text, $hlavicka)):
    return TRUE;
    else:
    return FALSE;
    endif; 
}
?>